/*
 * Name:     CDocumentObserver.cpp
 *
 *
 * Class:    CDocumentObserver
 * Header:   CDocumentObserver.h
 * Created : Feb 26, 2010
 * Author :  Kenji Aono
 */

#include "wx/prec.h"
#include "CDocumentObserver.h"
#include "CDocument.h"

/*
 * Name :        CDocumentObserver::CDocumentObserver()
 * Description : Document observer class constructor.
 */
CDocumentObserver::CDocumentObserver()
{
}

/*
 * Name :        CDocumentObserver::CDocumentObserver()
 * Description : Constructor for a document observer.
 */
CDocumentObserver::CDocumentObserver(CDocument *document) : mDocument(document)
{
    mDocument->AddObserver(this);
}

/*
 * Name :        CDocumentObserver::~CDocumentObserver()
 * Description : Destructor for an observer. Disconnects us from the document we are
 *               observing.
 */
CDocumentObserver::~CDocumentObserver()
{
    mDocument->RemoveObserver(this);
}
