/*
 * Name:     CIterator.h
 *
 *
 * Class:    CIterator
 * Impl:     Exists in header
 * Created : Feb 26, 2010
 * Author :  Kenji Aono
 */

#pragma once
#ifndef CITERATOR_H_
#define CITERATOR_H_

/*
 * Class:    CIterator
 * Base class for iterators.
 */
template<class T> class CIterator
{
public:
    virtual ~CIterator() {}

    virtual void First() = 0;
    virtual void Next() = 0;
    virtual bool IsDone() = 0;
    virtual T Current() = 0;
};

template <class T> class CIteratorPtr
{
public:
    CIteratorPtr(CIterator<T> * i) : mIter(i) {}
    ~CIteratorPtr() {delete mIter;}

    CIterator<T> *operator->() {return mIter;}
    CIterator<T> &operator*() {return *mIter;}

private:
    CIteratorPtr() {}
    CIteratorPtr(const CIteratorPtr *) {}
    CIteratorPtr &operator=(CIteratorPtr &) {}

    CIterator<T> *mIter;
};

template <class T> class CNullIterator : public CIterator<T>
{
public:
    virtual void First() {}
    virtual void Next() {}
    virtual bool IsDone() {return true;}
    virtual T Current() {return 0;}
};

#endif /* ITERATOR_H_ */
