/*
 * Name:     CViewTimeline.cpp
 * This class manages the timeline window at the bottom of the screen.
 *
 * Class:    CViewTimeline
 * Header:   CViewTimeline.h
 * Created : Feb 20, 2010
 * Author :  Charles B. Owen - Initial distributed version
 * Co-Author: Kenji Aono
 */

#include "wx/prec.h"
#include "CViewTimeline.h"
#include "CFrame.h"

BEGIN_EVENT_TABLE(CViewTimeline, wxScrolledWindow)
END_EVENT_TABLE()

/*
 * Name :        CViewTimeline::CViewTimeline()
 * Description : Constructor for the timeline view.
 */
CViewTimeline::CViewTimeline(CFrame *frame) :
    wxScrolledWindow(frame, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxHSCROLL | wxSUNKEN_BORDER),
    CDocumentObserver(frame->GetDocument())
{
    // This is to force the window to have some space (50 pixels tall)
    SetMinSize(wxSize(100, 50));
}


/*
 * Name :        CViewTimeline::~CViewTimeline()
 * Description : Destructor for the timeline view.
 */
CViewTimeline::~CViewTimeline()
{
}

/*
 * Name :        CViewTimeline::UpdateObserver()
 * Description : Force an update of this window when the document changes.
 * Parameters :  none
 * Returns :     none
 */
void CViewTimeline::UpdateObserver()
{
    Refresh();
}
